/*
 * Funambol is a mobile platform developed by Funambol, Inc. 
 * Copyright (C) 2003 - 2007 Funambol, Inc.
 * 
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Affero General Public License version 3 as published by
 * the Free Software Foundation with the addition of the following permission
 * added to Section 15 as permitted in Section 7(a): FOR ANY PART OF THE COVERED
 * WORK IN WHICH THE COPYRIGHT IS OWNED BY FUNAMBOL, FUNAMBOL DISCLAIMS THE
 * WARRANTY OF NON INFRINGEMENT  OF THIRD PARTY RIGHTS.
 * 
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more 
 * details.
 * 
 * You should have received a copy of the GNU Affero General Public License
 * along with this program; if not, see http://www.gnu.org/licenses or write to
 * the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301 USA.
 * 
 * You can contact Funambol, Inc. headquarters at 643 Bair Island Road, Suite
 * 305, Redwood City, CA 94063, USA, or at email address info@funambol.com.
 * 
 * The interactive user interfaces in modified source and object code versions
 * of this program must display Appropriate Legal Notices, as required under
 * Section 5 of the GNU Affero General Public License version 3.
 * 
 * In accordance with Section 7(b) of the GNU Affero General Public License
 * version 3, these Appropriate Legal Notices must retain the display of the
 * "Powered by Funambol" logo. If the display of the logo is not reasonably
 * feasible for technical reasons, the Appropriate Legal Notices must display
 * the words "Powered by Funambol".
 */

#pragma once
#include "afxwin.h"
#include "CustomButton.h"
#include "CustomList.h"

class CPIMSettings : public CDialog
{
	DECLARE_DYNAMIC(CPIMSettings)

public:
	CPIMSettings(CWnd* pParent = NULL);   // standard constructor
	virtual ~CPIMSettings();

// Dialog Data
	enum { IDD = IDD_UI_PIM_OPTIONS };

protected:
    #if defined(WIN32_PLATFORM_PSPC)
        CComboBox lstSyncType;
    #endif
    
    #if defined(WIN32_PLATFORM_WFSP)
        CListBox lstSyncType;
        CSpinButtonCtrl spinSyncType;
    #endif
    
    int oldOrientation;       

    // reference to the list in the uiDlg;
    CCustomList& customList;
    
     // for font to be used. the lf for the 
    LOGFONT lf, pathlf;
    LOGFONT defaultFont;
    CFont fontBold;
    CFont defaultFontSize;
    CFont pathFontSize;

    void InitializeFont();
    SHMENUBARINFO dlgCommandBar;    
    bool createMenu();
             
    
    void initializeSyncDirection();
    
    void initializeSearchFolder(WindowsSyncSourceConfig* sconfig, int type);
    /**
     *  loads strings onto the dialog from the stringtable
     */
    void LoadStringResources();
    
    bool processKeyEvents(WPARAM key);

    CCustomButton linkNotesChoose;
    CCustomButton linkBriefcaseChoose;    

    void OnBnClickedNotesLinkChoose();
    void OnBnClickedBriefcaseLinkChoose();
    
    // The path for the folder used for notes, briefcase, picture.
    CString notesFolder;    
    CString briefcaseFolder;
    
    bool existsNote;        // set true if the notes are in the list of sources
    bool existsBriefcase;   // set true if the briefcase are in the list of sources
    
    bool changedDirectory(WindowsSyncSourceConfig* sconfig, CString folder);

    virtual BOOL OnInitDialog();
    virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
    virtual BOOL PreTranslateMessage(MSG* pMsg);

	DECLARE_MESSAGE_MAP()
    afx_msg void OnOK();

    /**
     *  called when selecting the "Advanced Settings" link
     */
    afx_msg void OnBnClickedPIMLinkAdvanced();

    HBRUSH OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor);

    afx_msg void OnSize(UINT /*nType*/, int /*cx*/, int /*cy*/);
};
